> For the complete documentation index, see [llms.txt](https://docs.rivalz.ai/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.rivalz.ai/adcs-ai-oracles/create-your-consumer-smart-contract.md).

# Create your consumer smart contract

## Understanding Adapter Output Formats

Before integrating any adapter into your smart contracts, it's crucial to understand its output format. This understanding is essential for successful integration and preventing potential contract errors.

## Create your consumer smart contract.

* You need to inherit you consumer contract from our list of contracts based on you specific usecase. You can find the list of contracts \[[here](https://github.com/Rivalz-ai/ADCS-core/blob/main/contracts)]
* Some core function of the smart contract you need to implement are:

```solidity
function requestBytes32Data(
    uint32 _callbackGasLimit,
    bytes32 _jobId,
    string memory _from
        ) external returns (uint256 requestId) {
        ADCS.Request memory req = buildRequest(_jobId, keccak256(abi.encodePacked("bytes32")));
        req.add("from", _from);
    requestId = COORDINATOR.requestData(_callbackGasLimit, req);
    emit DataRequestedBytes32(requestId);
}
```

You need to specify the `_jobId`, adapter parameters and `_callbackGasLimit` for the request.

```solidity
function fulfillDataRequest(uint256, bytes32 response) internal virtual override {
    lastBytes32 = response;
    /// You business logic here
}
```

You need to implement your business logic in the `fulfillDataRequest` function.

**Now you can deploy your contract and start requesting data from the ADCS platform**


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.rivalz.ai/adcs-ai-oracles/create-your-consumer-smart-contract.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
